package UI.GameState;

import UI.LogIn.Game.GameFrame;

import javax.imageio.ImageIO;
import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.util.Random;

public class RewardState {

    private WallState walls ;
    public int locX , locY;
    private boolean drawing = false;
    private Image reward;
    private boolean visible ;
    int numOfReward = chooseRandomReward();
    public static long startShieldTime;

    public RewardState(WallState wallState){
        this.walls = wallState ;
        setFirstLocationOfReward();
    }

    private void shield(TankState tank){
        tank.setHasShield(true);
        startShieldTime = System.currentTimeMillis();
    }

    private void laser(TankState tank){

    }

    private void extraLife(TankState tank){
    }

    private void extraBulletDamage(TankState tank){

    }

    private void extraBulletDamage2(TankState tank){
    }

    private void setFirstLocationOfReward() {
        Random randomX = new Random();
        Random randomY = new Random();
        while (true) {
            locX = randomX.nextInt(GameFrame.GAME_WIDTH);
            locY = randomY.nextInt(GameFrame.GAME_HEIGHT);
            if (!walls.isWallForTank(locX , locY) && locX > 10 && locY >10 && locX < GameFrame.GAME_WIDTH-10 && locY < GameFrame.GAME_HEIGHT -10)
                break;
        }
    }


    public int chooseRandomReward(){
        Random random = new Random();
        int x = random.nextInt(5);
        System.out.println(x);
        return x;
    }


    private Image rewardImage = null;
    public Image getRewardImage() throws IOException {
        this.drawing = drawing;
        if (drawing = true) {
            if (rewardImage!=null) return rewardImage;
            int x = numOfReward;
            switch (x) {
                case 0:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\shield.png"));break;
                case 1:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\heart.png"));break;
                case 2:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\bullet.png"));break;
                case 3:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\bullets.png"));break;
                case 4:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\laser.png"));break;
            }
            rewardImage = reward.getScaledInstance(30, 30, java.awt.Image.SCALE_SMOOTH);
            return rewardImage;
        }
        return null;
    }

    public void runReward(TankState tankState){
        int x = numOfReward;
        switch (x) {
            case 0:shield(tankState);break;
            case 1:extraLife(tankState);break;
            case 2:extraBulletDamage(tankState);break;
            case 3:extraBulletDamage2(tankState);break;
            case 4:laser(tankState);break;
        }
    }


    public boolean isRewardForTank (int x,int y){
        //BUG
        return (x>this.locX-40 && x<this.locX+40 && y>this.locY-40 && y<this.locY+40 && x < GameFrame.GAME_WIDTH - 40 && y<GameFrame.GAME_HEIGHT-30);
    }

    public boolean isVisible() {
        return visible;
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
    }
}
