package Server_Client;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;

public class Client {

    private String user_pass;
    public Client(String username, String password) {
        user_pass = username.trim() +"|"+ password.trim();
    }

    public void run(){
        System.out.println("client connected");
        try (Socket client =  new Socket(InetAddress.getLocalHost().getHostName(),5757)){
            OutputStream out = client.getOutputStream();
            PrintWriter writer = new PrintWriter(out,true);
            writer.println(user_pass);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
